/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 *  WebSphere sMash
 *
 * (C) Copyright IBM Corp. 2007,2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
        /* Copyright (c) 2008 by IBM Corporation */

dojo.provide("zero.ide.widget.appedit.IWidgetTestCreateDialog");

dojo.require("zero.ide.widget.appedit.IWidgetCreateDialog");

dojo.declare("zero.ide.widget.appedit.IWidgetTestCreateDialog",
             [zero.ide.widget.appedit.IWidgetCreateDialog],
{
    widgetsInTemplate: true,
    templatePath: dojo.moduleUrl("zero","ide/widget/appedit/templates/IWidgetTestCreateDialog.html"),		


    setUpCreate: function(appId, appPath, newFileInfoObj)
    {
		// summary: setUpCreate is called to setup the file create dialog
		//
		// appId: the id for the current application
		// appPath: the path for the current application
		// newFileInfoObj: the newFileInfoObj contains the componentType, path, example, newMenuLabel and 
		//                 extensions from the zero config file 		

		if(zlog.isDebug())console.debug("in setUpCreate for FileCreateDialog:"+this._uid);
		var path = newFileInfoObj.path;
		var newComponentType = newFileInfoObj.componentType;
		this.appPath = appPath;
		if (this.filePathCombo) {
			if (path) {
				this.filePathCombo.setDisplayedValue(path);
			}
			else {
		    	this.filePathCombo.setDisplayedValue('/');
			}
		}
		if (newFileInfoObj && newFileInfoObj.example) {		
		    this.example = newFileInfoObj.example;
		}
		var inst = 'For example, \"'+this.example+'\".';
		this.theDialogInstructions.innerHTML = inst; 
		
		this.componentType = newComponentType;		
		
		this.resourceString = this.baseResourceString +"/"+ currentApplication.id + "/files";
		this.templateResourceString = "appbuilder/templates/"+this.componentType;

		this.templateInstanceString = this.baseResourceString + "/"+ currentApplication.id + "/" + this.componentType;

		this.type = "create";

		this.appId = appId;
        
		
      if (!this.filePathCombo) {
	  	if(zlog.isDebug())console.debug("setUpCreate->creating filePathCombo");
		
        var _url = this.resourceString +'?metadata&recurse&flat&nofiles';
		

	    this.filePathStore = new zero.ide.data.ideFilePathStore ({
		             url: _url, resourceString:this.resourceString});					 		 
		 
        this.filePathCombo = new dijit.form.ComboBox({
			  id:this._uid+"-filePathCombo",
			  autoComplete:false,
			  store: this.filePathStore,
			  searchAttr:"path"
		   }, dojo.byId(this._uid+"-filePathCombo"));
		   dojo.style(this.filePathCombo.domNode, "width", "35em");
           dojo.addClass(this.filePathCombo, "filePathCombo");
		   var tnode = this.filePathCombo.childNodes
		   if (path) {		   		
				this.filePathCombo.setDisplayedValue(path);
		   }
		   else {		   		
		    	this.filePathCombo.setDisplayedValue('/');
		   }		   
		   if(zlog.isDebug())console.debug(this.filePathCombo);

		   this.filePathConnection = dojo.connect(this.filePathCombofilePathComboParentNode, 'onkeyup', this, 'checkForEnter');
           this.dirtyFileList = false;
		   this.dirtyListConnection = dojo.subscribe("FileListChanged", this, "fileListDirty");
		   
       } else {
		   if (this.dirtyFileList) {
				this.filePathStore.clear();
				this.dirtyFileList = false;
		   }
   	       var _url = this.resourceString+'?metadata&recurse&flat&nofiles';
           this.filePathStore.setUrl(_url, this.resourceString);
	   }	   
	   if (this.componentType) {
	   		if (!this.fileTemplateCombo) {
				if(zlog.isDebug())console.debug("setUpCreate->creating fileTemplateCombo:"+this.componentType);
			   	this.fileTemplateStore = new dojo.data.ItemFileReadStore({url: this.templateResourceString});
		  
        	   	this.fileTemplateCombo = new dijit.form.FilteringSelect ({
			   		id:this._uid+"-fileTemplateCombo",
			   		autoComplete:true,
			   		store: this.fileTemplateStore,
			   		searchAttr:"name"
		   		}, dojo.byId(this._uid+"-fileTemplateCombo"));
		   
		   		dojo.style(this.fileTemplateCombo.domNode, "width", "25em");
           		dojo.addClass(this.fileTemplateCombo, "filePathCombo");			 		   		

		        this.fileTemplateLiParentNode.title = "Select the template from the list.";

				// set the default value
           		this.fileTemplateStore.fetch({query:{name:"*"}, queryOptions:{deep:true}, count:1, onComplete: dojo.hitch(this, this.gotTemplates),
											   onError: dojo.hitch(this, this.failTemplates)});		   
		   		   
		   		this.fileTemplateConnection = dojo.connect(this.fileTemplateComboParentNode, 'onkeyup', this, 'checkForEnter');
		   }
		   else		     	   			  
		   {			  		   		
						   				   	
				// Combobox already exists, refresh the list of template files
		   		this.fileTemplateStore._arrayOfAllItems = [];
		   		this.fileTemplateStore._arrayOfTopLevelItems = [];
		   		this.fileTemplateStore._loadFinished = false;
				this.fileTemplateStore.url = this.templateResourceString;
				this.fileTemplateStore._jsonFileUrl = this.templateResourceString;					
				
				// set the default value			
				this.fileTemplateStore.fetch({query:{name:"*"}, queryOptions:{deep:true}, count:1, onComplete: dojo.hitch(this, this.gotTemplates),
												onError: dojo.hitch(this, this.failTemplates)});													
		   }
	   }
	   else {	   	
	   		this._showTemplateComboBox(false);		   	
		    this.fileTemplateLiParentNode.title = "";
	   }
	   
	   this.filePathCombo.textbox.focus();
	   this.checkForCreateDisabled();
	   if(zlog.isDebug())console.debug("~ setUpCreate->creating filePathCombo");

    },


    show: function(displayPath)
    {			    	
		if (currentApplication.path) {
			var appPath = currentApplication.path + currentApplication.name;
			this.newFileAppRootNode.title = appPath;
        }
		if ((displayPath) && (this.filePathCombo)) {					
			this.filePathCombo.setDisplayedValue(displayPath);
		}

        this.theDialog.show();
        this.theDialog.closeButtonNode.style.display = '';
        if(zlog.isDebug())console.debug(this.theDialog);
    },
	
	getPath: function()
    {
        var zwname = this.filePathCombo.getValue();
		//p = "/app/iwidgets/" + zwname + "/" + zwname;
		//p = "/public/" + zwname;	
        var p = zwname;
		if (p.indexOf('/') !== 0) {
			p = '/'+p;
		}
		
		return this.resourceString+p;		
		//return this.resourceString+p+".html";
    },

    checkForCreateDisabled: function(pEvent)
    {
		if(zlog.isDebug())console.debug("in IWidgetCreateDialog checkForCreateDisabled");
		var zwpackage = (this.zwPackageInput.getValue().length > 0) && this.zwPackageInput.isValid();
		
		var path = this.filePathCombo.getValue();

		var endslashb = path.lastIndexOf("/") == path.length - 1;

		var fileExists = this._filePathInAllList(path); 
		this.lastPathTested = path;
		this.lastzwpackageTested = zwpackage;
		
        if (path.length == 0 || !zwpackage ||
		    endslashb || fileExists) {
            this.createButton.setAttribute('disabled',true);
			this.disabledButton = true;
			return true;
		} else {
            this.createButton.setAttribute('disabled',false);
			this.disabledButton = false;
		    if (pEvent && pEvent.keyCode == dojo.keys.ENTER) {
				this._fileCreate();
				this.hide();
			}			
			return false;
		}
    },
	
    getTemplateInstancePath: function()
    {
		var zwname = this.filePathCombo.getValue();
		var zwpackage = this.zwPackageInput.getValue();
		var p = zwname;
		if (p.indexOf('/') !== 0) {
			p = '/'+p;
		}
		var widurl = "/iwidgets/"+ zwpackage +"/"+zwpackage+".xml";
		var retString = this.templateInstanceString+p+"?template="+this.getTemplateName()+"&iwdesc="+widurl+"&iwname="+zwname;

		return retString;
    },	
	
	getTemplateName: function()
	{
		if (this.fileTemplateCombo != null) {
			var t = this.fileTemplateCombo.getValue() + "/default.html";
			return t;
		}
		else {	
			return null;
		}
	},

	fileListDirty: function() {
        this.dirtyFileList = true;
	},
	
	
	openTitle: "Create an iWidget Test html file"	
});
