/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 *  WebSphere sMash
 *
 * (C) Copyright IBM Corp. 2007,2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
        /* Copyright (c) 2008 by IBM Corporation */

dojo.provide("zero.ide.widget.appedit.ZWidgetCreateDialog");

dojo.require("zero.ide.widget.appedit.FileCreateDialog");
dojo.require("dijit.form.ValidationTextBox");
dojo.require("dijit.form.CheckBox");


dojo.declare("zero.ide.widget.appedit.ZWidgetCreateDialog",
             [zero.ide.widget.appedit.FileCreateDialog],
{
    widgetsInTemplate: true,
    templatePath: dojo.moduleUrl("zero","ide/widget/appedit/templates/ZWidgetCreateDialog.html"),
	
	setUpCreate: function(appId, appPath, newFileInfoObj)
    {
		// summary: setUpCreate is called to setup the file create dialog
		//
		// appId: the id for the current application
		// appPath: the path for the current application
		// newFileInfoObj: the newFileInfoObj contains the componentType, path, example, newMenuLabel and 
		//                 extensions from the zero config file 		

		if(zlog.isDebug())console.debug("in setUpCreate for FileCreateDialog:"+this._uid);
		var path = newFileInfoObj.path;
		var newComponentType = newFileInfoObj.componentType;
		this.appPath = appPath;
		
		this.componentType = newComponentType;		
		
		this.resourceString = this.baseResourceString +"/"+ currentApplication.id + "/files";
		this.templateResourceString = "appbuilder/templates/"+this.componentType;

		this.templateInstanceString = this.baseResourceString + "/"+ currentApplication.id + "/" + this.componentType;

		this.type = "create";

		this.appId = appId;        
		
        if (this.componentType) {
	   		if (!this.fileTemplateCombo) {
				if(zlog.isDebug())console.debug("setUpCreate->creating fileTemplateCombo:"+this.componentType);
			   	this.fileTemplateStore = new dojo.data.ItemFileReadStore({url: this.templateResourceString});
		  
        	   	this.fileTemplateCombo = new dijit.form.FilteringSelect ({
			   		id:this._uid+"-fileTemplateCombo",
			   		autoComplete:true,
			   		store: this.fileTemplateStore,
			   		searchAttr:"name"
		   		}, dojo.byId(this._uid+"-fileTemplateCombo"));
		   
		   		dojo.style(this.fileTemplateCombo.domNode, "width", "25em");
           		dojo.addClass(this.fileTemplateCombo, "filePathCombo");			 		   		

		        this.fileTemplateLiParentNode.title = "Select the template from the list.";

				// set the default value
           		this.fileTemplateStore.fetch({query:{name:"*"}, queryOptions:{deep:true}, count:1, onComplete: dojo.hitch(this, this.gotTemplates),
											   onError: dojo.hitch(this, this.failTemplates)});		   
		   		   
		   		this.fileTemplateConnection = dojo.connect(this.fileTemplateComboParentNode, 'onkeyup', this, 'checkForEnter');
		   }
		   else		     	   			  
		   {			  		   		
						   				   	
				// Combobox already exists, refresh the list of template files
		   		this.fileTemplateStore._arrayOfAllItems = [];
		   		this.fileTemplateStore._arrayOfTopLevelItems = [];
		   		this.fileTemplateStore._loadFinished = false;
				this.fileTemplateStore.url = this.templateResourceString;
				this.fileTemplateStore._jsonFileUrl = this.templateResourceString;					
				
				// set the default value			
				this.fileTemplateStore.fetch({query:{name:"*"}, queryOptions:{deep:true}, count:1, onComplete: dojo.hitch(this, this.gotTemplates),
												onError: dojo.hitch(this, this.failTemplates)});													
		   }
	   }
	   else {	   	
	   		this._showTemplateComboBox(false);		   	
		    this.fileTemplateLiParentNode.title = "";
	   }
	   
	   this.zwPackageInput.focus();
	   this.checkForCreateDisabled();
	   if(zlog.isDebug())console.debug("~ setUpCreate->creating filePathCombo");

    },
	
    checkForCreateDisabled: function()
    {
		var zwpackage = (this.zwPackageInput.getValue().length > 0) && this.zwPackageInput.isValid();
		var zwname = (this.zwNameInput.getValue().length > 0) && this.zwNameInput.isValid();

        if (zwpackage&&zwname) {
			this.createButton.setAttribute('disabled',false);
			this.disabledButton = false;
			return false;
		} else {
            this.createButton.setAttribute('disabled',true);
			this.disabledButton = true;
			return true;
		}
    },	
	
	show: function(displayPath)
    {			    	
        this.theDialog.show();
        this.theDialog.closeButtonNode.style.display = '';
        if(zlog.isDebug())console.debug(this.theDialog);
    },
	
	getPath: function()
    {
        var p = this.zwPackageInput.getValue().replace(/\./g,"/");
//		p = p + "/" + this.zwNameInput.getValue();
		if (p.indexOf('/') !== 0) {
			p = '/'+p;
		}
		p = '/app/zwidgets' + p;		
		return this.resourceString+p;
    },

    getTemplateInstancePath: function()
    {
		var zwname = this.zwNameInput.getValue();
		var zwpackage = this.zwPackageInput.getValue();
        var p = zwpackage.replace(/\./g,"/");
//		p = p + "/" + zwname;
		if (p.indexOf('/') !== 0) {
			p = '/'+p;
		}
	
		return this.templateInstanceString+p+"?template="+this.getTemplateName()+"&zwpackage="+zwpackage+"&zwname="+zwname;
    },	
	
	_fileCreateError: function (data, ioArgs) 
	{
		// summary: _fileCreateError is called when the file was not created successfully
		this.createError = true;
		//dijit.byId('status-dialog').showDialog('Error','','A problem occurred while trying to create file '+this.filePathCombo.getValue());
		//alert("File Create Error - A problem occurred while trying to create file "+this.filePathCombo.getValue());
		var manager = dijit.byId('app-mgr-ui-id');					
		//manager._ideWidget.hideProgressDlg();
		var formattedMessage = "File Create Error - A problem occurred while trying to create file.";
		try{  // if we don't get an error msg use the generic one
			var errMsg = eval('(' + ioArgs.xhr.responseText + ')').errorMessage;
			//determine is its an array object before formatting message
			if (errMsg.constructor == Array) {
				for (var i = 0; i < errMsg.length; i++) {
					formattedMessage += errMsg[i] + "<br />";
				}
			}
			else {
				formattedMessage = errMsg + "<br />";
			}
		}catch(e){/*quiet*/}
        this.dlgConnection = dojo.connect(manager._statusDialog, 'hideDialog', this, 'showDlgAfterErrorMsg');
		manager._statusDialog.showDialog('Error', 'Create failed:', formattedMessage );
        //this.theDialog.show();
		//this.show();
	},	
	
	openTitle: "Create a Dojo Widget"	
});
